<?php
declare(strict_types = 1);

namespace DTInternet\DtiOnlineconsulting\Controller;

/**
 * (c) 2022 by Stefan Bublies@dt-internet.de
 */

class ValidateApiController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{

    /**
     * videoconsultingRepository
     *
     * @var \DTInternet\DtiOnlineconsulting\Domain\Repository\VideoconsultingRepository
     */
    protected $videoconsultingRepository = null;

    /**
     * @param \DTInternet\DtiOnlineconsulting\Domain\Repository\VideoconsultingRepository $videoconsultingRepository
     */
    public function injectVideoconsultingRepository(\DTInternet\DtiOnlineconsulting\Domain\Repository\VideoconsultingRepository $videoconsultingRepository)
    {
        $this->videoconsultingRepository = $videoconsultingRepository;
    }

    /**
     * @return string
     */
    public function validateAction(): string
    {
        $videoId = \TYPO3\CMS\Core\Utility\GeneralUtility::_GET('videoid');
        $result = $this->videoconsultingRepository->findByVideoid($videoId)->getFirst();
        if ($result) {
            $validateResult = [];
            $validateResult['appointmentUuid'] = $result->getVideoid();
            $validateResult['timestampStart'] = $result->getPreferreddate()->getTimestamp();
            $validateResult['timestampDuration'] = ($result->getTimestampduration() > 0 ? $result->getTimestampduration(): '120');
            $validateResult['maxUser'] = ($result->getMaxuser() > 0 ? $result->getMaxuser() : '2');

            return json_encode($validateResult);
        } else {
            return json_encode(array('state' => false));
        }

        return json_encode(array('state' => false));
    }
}
