<?php
namespace DTInternet\DtiOnlineconsulting\Domain\Model;


/***
 *
 * This file is part of the "dti_onlineconsulting" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2022 Stefan Bublies <bublies@dt-internet.de>, D&T Internet GmbH
 *
 ***/

use DTInternet\DtiUsermanagement\Utility\FeuserUtility;

/**
 * Livechat
 */
class Livechat extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * Random ChatId
     *
     * @var string
     */
    protected $chatid = '';


    /**
     * Benutzer:in
     */
    protected $feuser = '';

    /**
     * Agent
     *
     * @var int
     */
    protected $agent = '';

    /**
     * @var \DateTime
     */
    protected $crdate = null;


    /**
     * Returns the chatid
     *
     * @return string $chatid
     */
    public function getChatid()
    {
        return $this->chatid;
    }

    /**
     * Sets the chatid
     *
     * @param string $chatid
     * @return void
     */
    public function setChatid($chatid)
    {
        $this->chatid = $chatid;
    }

    /**
     * Sets the feuser
     * @param int $feuser
     * @return void
     */
    public function setFeuser($feuser)
    {
        $this->feuser = $feuser;
    }

    /**
     * Returns the agent
     *
     * @return int $agent
     */
    public function getAgent()
    {
        return $this->agent;
    }

    /**
     * Sets the agent
     *
     * @param int $agent
     * @return void
     */
    public function setAgent($agent)
    {
        $this->agent = $agent;
    }

}
