<?php
namespace DTInternet\DtiOnlineconsulting\Domain\Model;

/***
 *
 * This file is part of the "dti_onlineconsulting" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2022 Stefan Bublies <bublies@dt-internet.de>, D&T Internet GmbH
 *
 ***/

use DTInternet\DtiUsermanagement\Utility\FeuserUtility;

/**
 * Topicanswers
 */
class Topicanswers extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{
    /**
     * Antwort
     *
     * @var string
     */
    protected $answertext = '';

    /**
     * Benutzer:in
     *
     */
    protected $feuser = '';

    /**
     * Agent
     *
     */
    protected $agent = '';

    /**
     * @var \DateTime
     */
    protected $crdate = null;

    /**
     * Returns the answertext
     *
     * @return string $answertext
     */
    public function getAnswertext()
    {
        return $this->answertext;
    }

    /**
     * Sets the answertext
     *
     * @param string $answertext
     * @return void
     */
    public function setAnswertext($answertext)
    {
        $this->answertext = $answertext;
    }

    /**
     * Returns the feuser
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUser> $feuser
     */
    public function getFeuser()
    {
        return $this->feuser;
    }


    /**
     * Sets the feuser
     *
     * @param int $feuser
     * @return void
     */
    public function setFeuser($feuser)
    {
        $this->feuser = $feuser;
    }

    /**
     * Returns the agent
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUser> $agent
     */
    public function getAgent()
    {
        return $this->agent;
    }

    /**
     * Sets the agent
     *
     * @param int $agent
     * @return void
     */
    public function setAgent($agent)
    {
        $this->agent = $agent;
    }

    /**
     * Returns the creation date
     *
     * @return \DateTime $crdate
     */
    public function getCrdate()
    {
        return $this->crdate;
    }

    /**
     * FeUserData
     * @return mixed
     */
    public function getFeUserdata()
    {
        $feUserData = FeuserUtility::readFeUserDataSingle($this->feuser);
        return $feUserData;
    }

    /**
     * FeUserData
     * @return mixed
     */
    public function getAgentdata()
    {
        $agentData = FeuserUtility::readFeUserDataSingle($this->agent);
        return $agentData;
    }

}
