<?php
namespace DTInternet\DtiOnlineconsulting\Domain\Model;

/***
 *
 * This file is part of the "dti_onlineconsulting" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2022 Stefan Bublies <bublies@dt-internet.de>, D&T Internet GmbH
 *
 ***/

use DTInternet\DtiUsermanagement\Utility\FeuserUtility;

/**
 * Videoconsulting
 */
class Videoconsulting extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{
    /**
     * Videoid
     *
     * @var string
     */
    protected $videoid = '';

    /**
     * Password
     *
     * @var string
     */
    protected $password = '';

    /**
     * Beratungstermin
     *
     * @var \DateTime
     */
    protected $preferreddate = null;

    /**
     * Benutzer:in
     *
     */
    protected $feuser = '';

    /**
     * Agent
     *
     */
    protected $agent = '';

    /**
     * Terminlaenge
     *
     * @var int
     */
    protected $timestampduration = null;

    /**
     * MaxBenutzer
     *
     * @var int
     */
    protected $maxuser = null;

    /**
     * Information
     *
     * @var string
     */
    protected $information = '';

    /**
     * Startzeitpunkt
     *
     * @var int
     */
    protected $videostarttime = null;

    /**
     * Bestaetigt
     *
     * @var int
     */
    protected $confirmed = null;

    /**
     * @var \DateTime
     */
    protected $crdate = null;

    /**
     * Returns the videoid
     *
     * @return string $videoid
     */
    public function getVideoid()
    {
        return $this->videoid;
    }

    /**
     * Sets the videoid
     *
     * @param string $videoid
     * @return void
     */
    public function setVideoid($videoid)
    {
        $this->videoid = $videoid;
    }

    /**
     * Returns the password
     *
     * @return string $password
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * Sets the password
     *
     * @param string $password
     * @return void
     */
    public function setPassword($password)
    {
        $this->password = $password;
    }

    /**
     * Returns the preferreddate
     *
     * @return \DateTime $preferreddate
     */
    public function getPreferreddate()
    {
        return $this->preferreddate;
    }

    /**
     * Sets the preferreddate
     *
     * @param \DateTime $preferreddate
     * @return void
     */
    public function setPreferreddate(\DateTime $preferreddate)
    {
        $this->preferreddate = $preferreddate;
    }

    /**
     * Returns the feuser
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUser> $feuser
     */
    public function getFeuser()
    {
        return $this->feuser;
    }


    /**
     * Sets the feuser
     *
     * @param int $feuser
     * @return void
     */
    public function setFeuser($feuser)
    {
        $this->feuser = $feuser;
    }

    /**
     * Returns the agent
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FrontendUser> $agent
     */
    public function getAgent()
    {
        return $this->agent;
    }

    /**
     * Sets the agent
     *
     * @param int $agent
     * @return void
     */
    public function setAgent($agent)
    {
        $this->agent = $agent;
    }

    /**
     * FeUserData
     * @return mixed
     */
    public function getFeUserdata()
    {
        $feUserData = FeuserUtility::readFeUserDataSingle($this->feuser);
        return $feUserData;
    }

    /**
     * FeUserData
     * @return mixed
     */
    public function getAgentdata()
    {
        $agentData = FeuserUtility::readFeUserDataSingle($this->agent);
        return $agentData;
    }

    /**
     * Returns the timestampduration
     *
     * @return int $timestampduration
     */
    public function getTimestampduration()
    {
        return $this->timestampduration;
    }

    /**
     * Sets the timestampduration
     *
     * @param int $timestampduration
     * @return void
     */
    public function setTimestampduration($timestampduration)
    {
        $this->timestampduration = $timestampduration;
    }

    /**
     * Returns the maxuser
     *
     * @return int $maxuser
     */
    public function getMaxuser()
    {
        return $this->maxuser;
    }

    /**
     * Sets the maxuser
     *
     * @param int $maxuser
     * @return void
     */
    public function setMaxuser($maxuser)
    {
        $this->maxuser = $maxuser;
    }

    /**
     * Returns the information
     *
     * @return string $information
     */
    public function getInformation()
    {
        return $this->information;
    }

    /**
     * Sets the information
     *
     * @param string $information
     * @return void
     */
    public function setInformation($information)
    {
        $this->information = $information;
    }

    /**
     * Returns the videostarttime
     *
     * @return int $videostarttime
     */
    public function getVideoStarttime()
    {
        return $this->videostarttime;
    }

    /**
     * Sets the videostarttime
     *
     * @param int $videostarttime
     * @return void
     */
    public function setVideoStarttime($videostarttime)
    {
        $this->videostarttime = $videostarttime;
    }

    /**
     * Returns the confirmed
     *
     * @return int $confirmed
     */
    public function getConfirmed()
    {
        return $this->confirmed;
    }

    /**
     * Sets the confirmed
     *
     * @param int $confirmed
     * @return void
     */
    public function setConfirmed($confirmed)
    {
        $this->confirmed = $confirmed;
    }

    /**
     * Returns the creation date
     *
     * @return \DateTime $crdate
     */
    public function getCrdate()
    {
        return $this->crdate;
    }
}
