<?php

namespace DTInternet\DtiOnlineconsulting\Utility;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2023 Stefan Bublies <bublies@dt-internet.de>
 *
 *  All rights reserved
 *
 ***************************************************************/

use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\GeneralUtility;


class MailUtility
{
    /**
     * @param $mail
     * @param $template
     * @param $content
     * @param $subject
     * @return void
     */
    public function sendMail($mail, $template, $content, $subject) {
        $senderMail = $GLOBALS['TYPO3_CONF_VARS']['MAIL']['defaultMailFromAddress'];
        $reciverMail = $mail;

        // Create the message
        $mail = GeneralUtility::makeInstance(\TYPO3\CMS\Core\Mail\MailMessage::class);

        // Prepare and send the message
        $mail
            // Give the message a subject
            ->setSubject($subject)
            // Set the From address with an associative array
            ->from(new \Symfony\Component\Mime\Address($senderMail))
            // Set the To addresses with an associative array
            ->to(new \Symfony\Component\Mime\Address($reciverMail))
            // Give it a body
            ->html($this->renderEmailHtml($content, $template), 'text/html');

        // And finally do send it
        $mail->send();

    }

    /**
     * @param $content
     * @param $template
     * @return mixed
     */

    private function renderEmailHtml($content,$template)
    {
        $this->objectManager = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Extbase\Object\ObjectManager::class);
        $emailView = $this->objectManager->get('TYPO3\\CMS\\Fluid\\View\\StandaloneView');
        $extPath = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('dti_onlineconsulting');
        $templateRootPath = $extPath . "/Resources/Private/Templates/";
        $partialRootPath = $extPath . "/Resources/Private/Partials/Email/";
        $templatePathAndFilename = $templateRootPath . 'Email/' . $template . '.html';
        $emailView->setPartialRootPaths([$partialRootPath]);
        $emailView->setTemplatePathAndFilename($templatePathAndFilename);
        $emailView->assignMultiple(['contents' => $content]);
        $emailHtmlBody = $emailView->render();
        return $emailHtmlBody;
    }

}
