$(document).foundation()

var $body = $('body');
var $menuTrigger = $('#menuTrigger');
var $siteNavi = $("#siteNavi");

/*
  Sticky header
 */

$(function() {
  //caches a jQuery object containing the header element
  $(window).scroll(function() {
    var scroll = $(window).scrollTop();

    if (scroll >= 200) {
      $body.addClass("sticky-header");
    } else {
      $body.removeClass("sticky-header");
    }
    if (scroll >= 400) {
      $body.addClass("show-header");
    } else {
      $body.removeClass("show-header");
    }
  });
});

/*
  Menu
 */

$menuTrigger.click(function(e){
  e.preventDefault();
  $body.toggleClass('navi-open');
  $(this).blur();
});

$(document).mouseup(function(e)
{
  if ($body.hasClass('navi-open') && !$siteNavi.is(e.target) && $siteNavi.has(e.target).length === 0 && !$menuTrigger.is(e.target) && $menuTrigger.has(e.target).length === 0)
  {
    $body.removeClass('navi-open');
  }
});

/*
  Toggle registration mode
 */

var $toggleRegistrationMode = $("#notanonymus");

$toggleRegistrationMode.click(function(e) {
  if ($(this).is(':checked')) {
    $(".registerFullRegistration").show();
    $('*[data-registration="requiredForFullReg"]').prop('required',true);
  } else {
    $(".registerFullRegistration").hide();
    $('*[data-registration="requiredForFullReg"]').prop('required',false);
  }
});

/*
  Toggle PW
 */

const togglePassword = document.querySelector("#togglePassword");
const password = document.querySelector("#password");

togglePassword.addEventListener("click", function () {
  const type = password.getAttribute("type") === "password" ? "text" : "password";
  password.setAttribute("type", type);
  this.classList.toggle("shown");
});

/*
  Validate PW
 */

(function(){
  var password = document.querySelector('.password');

  var helperText = {
    charLength: document.querySelector('.helper-text .length'),
    lowercase: document.querySelector('.helper-text .lowercase'),
    uppercase: document.querySelector('.helper-text .uppercase'),
    special: document.querySelector('.helper-text .special')
  };

  var pattern = {
    charLength: function() {
      if( password.value.length >= 8 ) {
        return true;
      }
    },
    lowercase: function() {
      var regex = /^(?=.*[a-z]).+$/; // Lowercase character pattern

      if( regex.test(password.value) ) {
        return true;
      }
    },
    uppercase: function() {
      var regex = /^(?=.*[A-Z]).+$/; // Uppercase character pattern

      if( regex.test(password.value) ) {
        return true;
      }
    },
    special: function() {
      var regex = /^(?=.*[0-9_\W]).+$/; // Special character or number pattern

      if( regex.test(password.value) ) {
        return true;
      }
    }
  };

  // Listen for keyup action on password field
  password.addEventListener('keyup', function (){
    // Check that password is a minimum of 8 characters
    patternTest( pattern.charLength(), helperText.charLength );

    // Check that password contains a lowercase letter
    patternTest( pattern.lowercase(), helperText.lowercase );

    // Check that password contains an uppercase letter
    patternTest( pattern.uppercase(), helperText.uppercase );

    // Check that password contains a number or special character
    patternTest( pattern.special(), helperText.special );

    // Check that all requirements are fulfilled
    if( hasClass(helperText.charLength, 'valid') &&
      hasClass(helperText.lowercase, 'valid') &&
      hasClass(helperText.uppercase, 'valid') &&
      hasClass(helperText.special, 'valid')
    ) {
      addClass(password.parentElement, 'valid');
    }
    else {
      removeClass(password.parentElement, 'valid');
    }
  });

  function patternTest(pattern, response) {
    if(pattern) {
      addClass(response, 'valid');
    }
    else {
      removeClass(response, 'valid');
    }
  }

  function addClass(el, className) {
    if (el.classList) {
      el.classList.add(className);
    }
    else {
      el.className += ' ' + className;
    }
  }

  function removeClass(el, className) {
    if (el.classList)
      el.classList.remove(className);
    else
      el.className = el.className.replace(new RegExp('(^|\\b)' + className.split(' ').join('|') + '(\\b|$)', 'gi'), ' ');
  }

  function hasClass(el, className) {
    if (el.classList) {
      return el.classList.contains(className);
    }
    else {
      new RegExp('(^| )' + className + '( |$)', 'gi').test(el.className);
    }
  }

})();
